#include	<stdio.h>
#include	<fcntl.h>
#include	<string.h>
#include	<time.h>
#include	<unistd.h>
#include	<sys/stat.h>
#include	<sys/types.h>
#include	<sys/mman.h>
#include	<sys/utsname.h>
#include	<linux/i2c-dev.h>
#include	<linux/i2c.h>
#include	<sys/ioctl.h>

#include	"ov5647.h"


u_int8_t	cis_i2c_write	( u_int16_t, u_int8_t  );
u_int8_t	cis_i2c_read	( u_int16_t, u_int8_t* );
u_int8_t	m2p_i2c_write	( u_int16_t, u_int16_t  );
u_int8_t	m2p_i2c_read	( u_int16_t, u_int16_t* );
u_int8_t	cis_chk_id		( u_int16_t );
u_int8_t	m2p_chk_id		( u_int16_t );
void		cis_init		( int, int );
void		m2p_init		( void );
u_int8_t	m2p_chk_cis		( void );
void		cis_start		( void );
void		cis_stop		( void );
void		cis_mode		( u_int8_t );


u_int8_t	i2c_read_16_8bit (
	u_int8_t		slv_addr,
	u_int16_t		reg_addr,
	u_int8_t*		reg_data
) {
	int32_t			fd;
	u_int8_t		txbuf[2];
	struct			i2c_msg					msg[2];
	struct			i2c_rdwr_ioctl_data		packes;

	fd				= open( "/dev/i2c-1", O_RDWR|O_SYNC );
	if( fd < 0 ) {
		printf( "i2c device file open error!\n" );
		return -1;
	}

	txbuf[0]		= (reg_addr & 0xff00) >> 8;
	txbuf[1]		= (reg_addr & 0x00ff);

	msg[0].addr		= slv_addr;
	msg[0].flags	= 0,
	msg[0].len		= 2,
	msg[0].buf		= txbuf;

	msg[1].addr		= slv_addr;
	msg[1].flags	= I2C_M_RD;
	msg[1].len		= 1;
	msg[1].buf		= reg_data;

	packes.msgs		= msg;
	packes.nmsgs	= 2;

	if( ioctl(fd, I2C_RDWR, &packes) < 0 ) {
		printf( "i2c_read_16bit: failed to ioctl\n" );
		close( fd );
		return -1;
	}

	close( fd );
	return 0;
}

u_int8_t	i2c_write_16_8bit (
	u_int8_t		slv_addr,
	u_int16_t		reg_addr,
	u_int8_t		reg_data
) {
	int32_t			fd;
	u_int8_t		txbuf[3];
	struct			i2c_msg					msg[1];
	struct			i2c_rdwr_ioctl_data		packes;

	fd				= open( "/dev/i2c-1", O_RDWR|O_SYNC );
	if( fd < 0 ) {
		printf( "i2c device file open error!\n" );
		return -1;
	}

	txbuf[0]		= (reg_addr & 0xff00) >> 8;
	txbuf[1]		= (reg_addr & 0x00ff);
	txbuf[2]		= reg_data;

	msg[0].addr		= slv_addr;
	msg[0].flags	= 0,
	msg[0].len		= 3,
	msg[0].buf		= txbuf;

	packes.msgs		= msg;
	packes.nmsgs	= 1;

	if( ioctl(fd, I2C_RDWR, &packes) < 0 ) {
		printf( "i2c_write_16bit: failed to ioctl\n" );
		close( fd );
		return -1;
	}

	close( fd );
	return 0;
}


u_int8_t	i2c_read_16_16bit (
	u_int8_t		slv_addr,
	u_int16_t		reg_addr,
	u_int16_t*		reg_data
) {
	int32_t			fd;
	u_int8_t		txbuf[2];
	u_int8_t		rxbuf[2];
	struct			i2c_msg					msg[2];
	struct			i2c_rdwr_ioctl_data		packes;

	fd				= open( "/dev/i2c-1", O_RDWR|O_SYNC );
	if( fd < 0 ) {
		printf( "i2c device file open error!\n" );
		return -1;
	}

	txbuf[0]		= (reg_addr & 0xff00) >> 8;
	txbuf[1]		= (reg_addr & 0x00ff);

	msg[0].addr		= slv_addr;
	msg[0].flags	= 0,
	msg[0].len		= 2,
	msg[0].buf		= txbuf;

	msg[1].addr		= slv_addr;
	msg[1].flags	= I2C_M_RD;
	msg[1].len		= 2;
	msg[1].buf		= rxbuf;

	packes.msgs		= msg;
	packes.nmsgs	= 2;

	if( ioctl(fd, I2C_RDWR, &packes) < 0 ) {
		printf( "i2c_read_16bit: failed to ioctl\n" );
		close( fd );
		return -1;
	}
	*reg_data		= ((rxbuf[0] & 0x00ff) << 8) + (rxbuf[1] & 0x00ff);

	close( fd );
	return 0;
}

u_int8_t	i2c_write_16_16bit (
	u_int8_t		slv_addr,
	u_int16_t		reg_addr,
	u_int16_t		reg_data
) {
	int32_t			fd;
	u_int8_t		txbuf[4];
	struct			i2c_msg					msg[1];
	struct			i2c_rdwr_ioctl_data		packes;

	fd				= open( "/dev/i2c-1", O_RDWR|O_SYNC );
	if( fd < 0 ) {
		printf( "i2c device file open error!\n" );
		return -1;
	}

	txbuf[0]		= (reg_addr & 0xff00) >> 8;
	txbuf[1]		= (reg_addr & 0x00ff);
	txbuf[2]		= (reg_data & 0xff00) >> 8;
	txbuf[3]		= (reg_data & 0x00ff);

	msg[0].addr		= slv_addr;
	msg[0].flags	= 0,
	msg[0].len		= 4,
	msg[0].buf		= txbuf;

	packes.msgs		= msg;
	packes.nmsgs	= 1;

	if( ioctl(fd, I2C_RDWR, &packes) < 0 ) {
		printf( "i2c_write_16bit: failed to ioctl\n" );
		close( fd );
		return -1;
	}

	close( fd );
	return 0;
}


u_int8_t	cis_i2c_read (
	u_int16_t		reg_addr,
	u_int8_t*		reg_data
) {
	i2c_read_16_8bit	( I2C_SADR_OV5647, reg_addr, reg_data );
	printf( "Register Read  OV5647   : addr=0x%04x data=0x%02x\n", reg_addr, *reg_data );

	return 0;
}

u_int8_t	cis_i2c_write (
	u_int16_t		reg_addr,
	u_int8_t		reg_data
) {
	i2c_write_16_8bit	( I2C_SADR_OV5647, reg_addr, reg_data );
	printf( "Register Write OV5647   : addr=0x%04x data=0x%02x\n", reg_addr,  reg_data );

	return 0;
}

u_int8_t	m2p_i2c_read (
	u_int16_t		reg_addr,
	u_int16_t*		reg_data
) {
	i2c_read_16_16bit	( I2C_SADR_TC358748, reg_addr, reg_data );
	printf( "Register Read  TC358748 : addr=0x%04x data=0x%04x\n", reg_addr, *reg_data );

	return 0;
}

u_int8_t	m2p_i2c_write (
	u_int16_t		reg_addr,
	u_int16_t		reg_data
) {
	i2c_write_16_16bit	( I2C_SADR_TC358748, reg_addr, reg_data );
	printf( "Register Write TC358748 : addr=0x%04x data=0x%04x\n", reg_addr,  reg_data );

	return 0;
}


u_int8_t	cis_chk_id (
	u_int16_t		id
) {
	u_int8_t		reg_data[2];
	u_int8_t		id_data[2];

	if( i2c_read_16_8bit(I2C_SADR_OV5647, OV5647_ADR_ID_U, &reg_data[0]) != 0 ) {
		printf( "### OV5647   I2C access NG!\n" );
		return -1;
	}
	if( i2c_read_16_8bit(I2C_SADR_OV5647, OV5647_ADR_ID_L, &reg_data[1]) != 0 ) {
		printf( "### OV5647   I2C access NG!\n" );
		return -1;
	}

	id_data[0]		= id >> 8;
	id_data[1]		= id & 0xff;
	if( reg_data[0] == id_data[0] && reg_data[1] == id_data[1] ) {
		printf( "### OV5647   ID verify OK! : read ID=0x%02x%02x\n", reg_data[0], reg_data[1] );
		return 0;
	}
	else {
		printf( "### OV5647   ID verify NG! : read ID=0x%02x%02x\n", reg_data[0], reg_data[1] );
		return 1;
	}
}


u_int8_t	m2p_chk_id (
	u_int16_t		id
) {
	u_int16_t		reg_data;

	if( i2c_read_16_16bit(I2C_SADR_TC358748, TC358748_ADR_ID, &reg_data) != 0 ) {
		printf( "### TC358748 I2C access NG!\n" );
		return -1;
	}

	if( reg_data == id ) {
		printf( "### TC358748 ID verify OK! : read ID=0x%04x\n", reg_data );
		return 0;
	}
	else {
		printf( "### TC358748 ID verify NG! : read ID=0x%04x\n", reg_data );
		return 1;
	}
}


void		cis_init (
	int				video_res,
	int				data_mode
) {

	int				i;
    printf( "### OV5647 Initialize start -->\n" );

	if		( video_res == 1080 ) {
		for( i=0; mode_1920_1080_regs[i].addr!=0xFFFF; i++ ) {
			cis_i2c_write	( mode_1920_1080_regs[i].addr, mode_1920_1080_regs[i].data );
		}
	}
	else if	( video_res == 480 ) {
		for( i=0; mode_640_480_regs[i].addr!=0xFFFF; i++ ) {
			cis_i2c_write	( mode_640_480_regs[i].addr, mode_640_480_regs[i].data );
		}
	}

    printf( "--> OV5647 Initialize end ###\n" );
}


void		m2p_init( void ) {
	
    printf( "### TC358748 Initialize start -->\n" );

    printf( "TC358748 Software Reset\n" );
    m2p_i2c_write( 0x0002, 0x0001 );		// SYSctl, S/W Reset
	usleep( 10 );
    m2p_i2c_write( 0x0002, 0x0000 );		// SYSctl, S/W Reset release

    printf( "TC358748 PLL,Clock Setting\n" );
    m2p_i2c_write( 0x0016, 0x0015 );		// PLL Control Register 0 (PLL_PRD,PLL_FBD)
    m2p_i2c_write( 0x0018, 0x0403 );		// PLL_FRS,PLL_LBWS, PLL oscillation enable
	usleep( 1000 );
    m2p_i2c_write( 0x0018, 0x0413 );		// PLL_FRS,PLL_LBWS, PLL clock out enable
    m2p_i2c_write( 0x0020, 0x0011 );		// CLK control register: Clock divider setting
    m2p_i2c_write( 0x000C, 0x0101 );		// MCLK duty setting

    printf( "TC358748 Format configuration, timing Setting\n" );
    // Rx Control Registers
    m2p_i2c_write( 0x0060, 0x8009 );		// MIPI PHY Time Delay

    m2p_i2c_write( 0x0006, 0x0010 );		// FIFO control
    m2p_i2c_write( 0x0008, 0x0010 );		// Data format control
    m2p_i2c_write( 0x0004, 0x004d );		// Configuration control

    printf( "--> TC358748 Initialize end ###\n" );
}


u_int8_t	m2p_chk_cis ( void ) {

	u_int16_t		reg_data		= 0;

    m2p_i2c_write( 0x0066, 0x01ff );		// CIS-2 Error Enable
    m2p_i2c_read ( 0x0064, &reg_data );		// CIS-2 Error Status
    m2p_i2c_write( 0x0064, reg_data );		// CIS-2 Error Status clear

	usleep( 10000 );
    m2p_i2c_read ( 0x0064, &reg_data );		// CIS-2 Error Status

	if( reg_data == 0 ) {
		printf( "### TC358748 CIS-2 status is Normal! : Status=0x%04x\n", reg_data );
		return 0;
	}
	else {
		printf( "### TC358748 CIS-2 status is Error!  : Status=0x%04x\n", reg_data );
		return -1;
	}
}


void		cis_start ( void ) {

    printf( "### OV5647 Streaming -->\n" );
	cis_i2c_write( 0x4800, 0x04 );
	cis_i2c_write( 0x4202, 0x00 );
	cis_i2c_write( 0x300D, 0x00 );
	usleep( 1000 );
}

void		cis_stop ( void ) {

    printf( "--> OV5647 Standby ###\n" );
	cis_i2c_write( 0x4800, 0x25 );
	cis_i2c_write( 0x4202, 0x0f );
	cis_i2c_write( 0x300D, 0x01 );
	usleep( 1000 );

	cis_i2c_write( 0x3000, 0x00 );
	cis_i2c_write( 0x3001, 0x00 );
	cis_i2c_write( 0x3002, 0x00 );
}

void		cis_mode (
	u_int8_t		mode
) {

	u_int8_t		reg			= 0;
	u_int8_t		sel			= mode % 4;

	switch( sel ) {
		case( 1 ):	reg			= 0x80;		// Test pattern: color bar type1
					break;
		case( 2 ):	reg			= 0x92;		// Test pattern: square black-white
					break;
		case( 3 ):	reg			= 0x82;		// Test pattern: square color
					break;
		default:	reg			= 0x00;		// Input data
					break;
	}
	printf( "mode=%x, sel=%x, reg=%x\n", mode, sel, reg );

	cis_i2c_write( 0x503D, reg );			// Test Pattern mode
}

